package de.jottyfan.timetrack.modules;

import java.sql.SQLException;

import javax.faces.application.FacesMessage;

import org.jooq.CloseableDSLContext;
import org.jooq.TableLike;

import de.jooqfaces.JooqFacesContext;

/**
 * 
 * @author henkej
 *
 */
public class JooqGateway {
	private final JooqFacesContext facesContext;

	public JooqGateway(JooqFacesContext facesContext) {
		this.facesContext = facesContext;
	}

	public CloseableDSLContext getJooq() throws ClassNotFoundException, SQLException {
		return facesContext.getJooq();
	}
	
	public void addToSessionMap(String key, Object value) {
		facesContext.getExternalContext().getSessionMap().put(key, value);
	}

	public Integer getFkLogin() {
		SessionBean bean = (SessionBean) facesContext.getExternalContext().getSessionMap().get("sessionBean");
		if (bean == null) {
			facesContext.addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, "schwerer Anwendungsfehler",
					"no sessionBean found in session, therefore, set fkLogin to 1"));
			bean = new SessionBean();
			bean.setLogin(1);
		}
		return bean.getLogin();
	}

	/**
	 * return amount of "select count(1) as amount " + subQuery
	 * 
	 * @param subQuery
	 * @return number of entries
	 * @throws ClassNotFoundException
	 * @throws SQLException
	 */
	public Long getAmount(TableLike<?> table) throws ClassNotFoundException, SQLException {
		return getJooq().selectCount().from(table).fetchOne(0, long.class);
	}
}
